#!-PERL-
# addtextrect.pl
# Copyright : Norwegian Telecom Research, 1993
# Programming : Jon Stephenson von Tetzchner
# This file can be changed and modified as long as this
# header is kept intact. This code can not be included
# in a commercial product.

# This script is part of the fm2html package.

# Parameters: infile, outfile, list of textrects

$| = 1;

$infile=shift;
$outfile=shift;

$numtextrectids=0;
$numfound = 0;

while (@ARGV)
{
	$textrectids[$numtextrectids] = shift;
	$numtextrectids +=1;
}

$infile.=".mif";

$textflow="";
$found=0;
$fig=0;

open(INFILE,$infile) || die("addtextrect: Could not open input file: $infile\n");
open(OUTFILE,">>$outfile") || die("addtextrect: Could not open output file: $outfile\n");

PRELOOP:
while (<INFILE>)
{
	if (/^<TextFlow /) 
	{
		$textflow=$_;
		last PRELOOP;
	}
}

LOOP:
while (<INFILE>) 
{
	$textline = $_;
	if ($textline =~ /^<TextFlow / || $textflow ne "") 
	{
		$textflow.=$textline;
	}
	if ($textline =~ /<TextRectID/ && !$fig) 
	{
		$temp = 0;
		while ($temp < $numtextrectids && !$found)
		{
			if ($textline =~ /<TextRectID $textrectids[$temp]>/)
			{
				$found=1;
			}
			$temp +=1;
		}
	} 
	elsif ($textline =~ /<PgfTag \`figur\'>/) 
	{
		$fig=1;
	} 
	elsif ($textline =~ /^> # end of TextFlow/) 
	{
		if ($found) 
		{
			print OUTFILE $textflow;
			$found = 0;
			undef $textflow;
			$textflow = "";
			$numfound++;
			if ($numfound == $numtextrectids)
			    {
				last LOOP;
			    }
		} 
		else 
		{
			$fig=0;
			undef $textflow;
			$textflow = "";
		}
	}
}

close OUTFILE;
close INFILE;


